unit main;

interface

uses
    Windows, Messages, SysUtils, Classes, Forms, Controls, Menus, Graphics,
    ExtCtrls, StdCtrls, Buttons, ActnList, StdActns, ImgList, ComCtrls,
  ToolWin;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    ActionList: TActionList;
    WindowClose1: TWindowClose;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowArrange1: TWindowArrange;
    MenuWindow: TMenuItem;
    MenuArrangeIcon: TMenuItem;
    MenuCascade: TMenuItem;
    MenuClose: TMenuItem;
    MenuMinimizeAll: TMenuItem;
    MenuTileHorizontal: TMenuItem;
    MenuTileVertical: TMenuItem;
    Panel1: TPanel;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList: TImageList;
    ImgBack: TImage;
    ToolButton4: TToolButton;
    MenuConfig: TMenuItem;
    ConfigPutSetFore: TAction;
    MenuPutSetFore: TMenuItem;
    ToolButton5: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    procedure ClientWndProc(var Msg: TMessage);
    procedure CreateMDIChild(const Name: string);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
    procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
  private
    FStrBuf: TStringList;
  protected
    procedure CreateParams(var Params: TCreateParams);override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
    MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const
    UNIQUE_NAM: string = '{FC63976B-527F-4A43-B7CC-7D57B0E940A1}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

{$R *.dfm}

uses
    child, ShellApi;

//-----------------------------------------------------------------------------
//  RXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
end;
//-----------------------------------------------------------------------------
//  fXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    R: TRect;
begin
    case Msg.Msg of

    //  wi`掞
    WM_ERASEBKGND:
        begin
            //  MDINCAg̈擾
            Windows.GetClientRect(ClientHandle, R);
            //  w̃rbg}bvœhԂ
            Brush.Bitmap := ImgBack.Picture.Bitmap;
            FillRect(TWMEraseBkgnd(Msg).DC, R, Brush.Handle);
            Brush.Bitmap := nil;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    FileName: Array[0..MAX_PATH] of Char;
    i, Count: integer;
begin
    //  hbvꂽt@C̐擾
    Count := DragQueryFile(Msg.Drop, DWORD(-1), FileName, SizeOf(FileName));
    for i := 0 to Count - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
        //  ꂪt@CȂ
        if (FileExists(FileName)) then
        begin
            //  qʋN
            CreateMDIChild(FileName);
        end;
        //  őOʂɎĂ
        if (MenuPutSetFore.Checked) then SetForegroundWindow(Application.Handle);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  ʂ̃CX^X瑗Ăe
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.WMCopyData(var Msg: TWMCopyData);
var
    i: integer;
    Buf: PChar;
begin
    if Msg.CopyDataStruct.dwData = UNIQUE_NUM then
    begin
        Buf := StrALloc(Msg.CopyDataStruct.cbData);
        try
            StrCopy(Buf, Msg.CopyDataStruct.lpData);
            FStrBuf.CommaText := Buf;
        finally
            StrDispose(Buf);
        end;
        for i := 0 to FStrBuf.Count - 1 do
        begin
            CreateMDIChild(FStrBuf.Strings[i]);
        end;
    end
    else inherited;
end;

//-----------------------------------------------------------------------------
//  qʍ쐬
procedure TMainForm.CreateMDIChild(const Name: string);
var
    Child: TMDIChild;
begin
    Child := TMDIChild.Create(Application);
    Child.Caption := Name;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  GpXg쐬
    FStrBuf := TStringList.Create;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  GpXgj
    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        CreateMDIChild(ParamStr(i));
    end;
end;

end.
